package mpi.eudico.client.annotator.commands;

import mpi.eudico.client.annotator.util.ClientLogger;

/**
 * 
 * A command that initates the process of adding a comment.
 * 
 * @author Olaf Seibert
 *
 */
public class AddCommentCommand implements UndoableCommand, ClientLogger  {

	 private String commandName;

	/** A command to add a comment to an annotation or time slice.
	  *
	  * @param name the name of the command
	  */
	 public AddCommentCommand(String name) {
		 LOG.info("AddCommentCommand(): " + name);
	     commandName = name;	       
	 }
	 
	@Override
	public void execute(Object receiver, Object[] arguments) {
		// TODO Auto-generated method stub
		LOG.info("AddCommentCommand.execute()");		
	}

	 /**
	   * Returns the name of the command.
	   *
	   * @return the name of the command
	   */
	@Override
	 public String getName() {
		 LOG.info("AddCommentCommand.getName: " + commandName);
		 return commandName;
	 }

    /**
     * The undo action.
     */
	@Override
	public void undo() {
		// TODO Auto-generated method stub
		LOG.info("AddCommentCommand.undo()");
	}

    /**
     * The redo action.
     */
	@Override
	public void redo() {
		// TODO Auto-generated method stub
		LOG.info("AddCommentCommand.redo()");
		
	}
}
