package mpi.eudico.client.annotator.interlinear.edit;

import java.util.List;

import nl.mpi.lexan.annotyzers.helpers.Information;

/**
 * Very preliminary and temporary config class.
 *
 */
public class AnnotConfig {
	protected Information annotId;
	protected String src;
	protected List<String> dest;
	protected boolean typeMode;
	
	
	/**
	 * @param annotId
	 * @param src
	 * @param dest
	 * @param typeMode, true, if this is linguistic based config
	 */
	public AnnotConfig(Information annotId, String src, List<String> dest, boolean typeMode) {
		super();
		this.annotId = annotId;
		this.src = src;
		this.dest = dest;
		this.typeMode = typeMode;
	}
	
	/**
	 * @param annotId
	 * @param src
	 * @param dest
	 */
	public AnnotConfig(Information annotId, String src, List<String> dest) {
		this(annotId, src, dest, false);
	}
	
	public Information getAnnotId() {
		return annotId;
	}

	public String getSource() {
		return src;
	}

	public List<String> getDest() {
		return dest;
	}
	
	public boolean isTypeMode() {
		return typeMode;
	}

	public boolean equals(Object obj) {
		if (obj == this) {
			return true;
		}
		if (obj == null || !(obj instanceof AnnotConfig)) {
			return false;
		}
		AnnotConfig other = (AnnotConfig) obj;
		if ( (annotId != null && annotId.equals(other.getAnnotId())) && 
				(src != null && src.equals(other.getSource())) && 
				(dest != null && dest.equals(other.getDest())) &&
				(typeMode == other.isTypeMode())) {
			return true;
		}
		
		return false;
	}
}
