package mpi.eudico.client.annotator.interlinear.edit;

import java.util.ArrayList;
import java.util.List;

import nl.mpi.lexan.annotyzers.helpers.Information;
import mpi.eudico.client.annotator.interlinear.edit.AnnotConfig;

/**
 * Class extends AnnotConfig fro type based configurations
 * to be documented
 * 
 */
public class AnnotTypeConfig extends AnnotConfig{
	
	protected List<AnnotConfig> tierConfList;
	private List<String> excludedTiersList;
	
	/**
	 * @param annotId
	 * @param src
	 * @param dest
	 */
	public AnnotTypeConfig(Information annotId, String src, List<String> dest) {
		this(annotId, src, dest, true);
	}
	
	/**
	 * @param annotId
	 * @param src
	 * @param dest
	 * @param typeMode
	 */
	public AnnotTypeConfig(Information annotId, String src, List<String> dest, boolean typeMode) {
		super(annotId, src, dest, typeMode);	
		
		tierConfList = new ArrayList<AnnotConfig>();
		excludedTiersList = new ArrayList<String>();
	}
	
	public List<AnnotConfig> getTierConfigurations(){
		return tierConfList;
	}
	
	public List<String> getExcludedTierList(){
		return excludedTiersList;
	}
	
	public void addTierConf(AnnotConfig ac){
		if(!tierConfList.contains(ac)){
			tierConfList.add(ac);
		}
		
		if(excludedTiersList.contains(ac.getSource())){
			excludedTiersList.remove(ac.getSource());
		}
	}
	
	public void removeTierConf(AnnotConfig ac){
		if(tierConfList.contains(ac)){
			tierConfList.remove(ac);
		}
		
		if(!excludedTiersList.contains(ac.getSource())){
			excludedTiersList.add(ac.getSource());
		}
	}
}
