package mpi.eudico.client.annotator.interlinear.edit;

import java.util.List;

//import javax.swing.JPopupMenu;

import mpi.eudico.client.annotator.interlinear.edit.actions.IGTEditAction;
import mpi.eudico.client.annotator.interlinear.edit.model.IGTAnnotation;

/**
 * An interface specifying methods for setting up and providing 
 * (ui) elements needed for editing IGT annotations. 
 * 
 * @author Han Sloetjes
 *
 */
public interface IGTEditProvider {

	/**
	 * Creates and initializes a popup menu containing editing options for a particular
	 * annotation.
	 * 
	 * @param igtAnn the annotation
	 * @return a popup menu
	 */
	//public JPopupMenu popupForAnnotation(IGTAnnotation igtAnn);
	
	/**
	 * Returns a List of Action objects for the given annotation.
	 * 
	 * @param igtAnnotation the annotation to list the actions for
	 * @return a list of actions
	 */
	public List<IGTEditAction> actionsForAnotation(IGTAnnotation igtAnnotation);
}
