package mpi.eudico.client.annotator.interlinear.edit.actions;

import java.awt.event.ActionEvent;
import java.util.LinkedList;
import java.util.List;

import javax.swing.Icon;

import nl.mpi.lexan.annotyzers.helpers.Position;
import nl.mpi.lexan.annotyzers.helpers.Suggestion;
import nl.mpi.lexan.annotyzers.helpers.SuggestionSet;

import mpi.eudico.client.annotator.interlinear.edit.IGTViewer;
import mpi.eudico.client.annotator.interlinear.edit.MediatorOutConnector;
import mpi.eudico.client.annotator.interlinear.edit.event.SuggestionSetEvent;
import mpi.eudico.client.annotator.interlinear.edit.model.IGTAnnotation;
/**
 * Temporary class to create a list suggestion sets.
 * 
 * @author Han
 *
 */
public class SuggestionSetMockup extends IGTEditAction {
	//private MediatorOutConnector mediator;
	private IGTViewer viewer;
	
	public SuggestionSetMockup(IGTAnnotation igtAnnotation, IGTViewer viewer) {
		super(igtAnnotation);
		this.viewer = viewer;
	}

	public SuggestionSetMockup(IGTAnnotation igtAnnotation, IGTViewer viewer, String label) {
		super(igtAnnotation, label);
		this.viewer = viewer;
	}

	public SuggestionSetMockup(IGTAnnotation igtAnnotation, IGTViewer viewer, String label,
			Icon icon) {
		super(igtAnnotation, label, icon);
		this.viewer = viewer;
	}

	@Override
	public void actionPerformed(ActionEvent arg0) {
		if (igtAnnotation != null && viewer != null) {
			Position pos = new Position();
			pos.tierId = igtAnnotation.getAnnotation().getTier().getName();
			pos.beginTime = igtAnnotation.getAnnotation().getBeginTimeBoundary();
			pos.endTime = igtAnnotation.getAnnotation().getEndTimeBoundary();
			
			//mediator.annotyze(pos);
			//bypass the route via the mediator, create some custom suggestions
			List<SuggestionSet> suggestionSets = new LinkedList<SuggestionSet>();
			// first suggestion set
			SuggestionSet ss = new SuggestionSet();
			Suggestion s1 = new Suggestion();
			s1.content = "aaa";
			s1.position = new Position("mor-sp2", pos.beginTime, pos.endTime);
			
			Suggestion sc1 = new Suggestion();
			sc1.content = "agl1";
			sc1.position = new Position("gl-sp2", pos.beginTime, pos.endTime);
			s1.children.add(sc1);
			
			Suggestion sc2 = new Suggestion();
			sc2.content = "aps1";
			sc2.position = new Position("ps-sp2", pos.beginTime, pos.endTime);
			//s1.children.add(sc2);//ps-sp2 is 
			
			ss.suggestions.add(s1);
			ss.suggestions.add(sc2);
			suggestionSets.add(ss);
			
			ss = new SuggestionSet();
			Suggestion s2 = new Suggestion();
			s2.content = "bb1";
			s2.position = new Position("mor-sp2", pos.beginTime, pos.endTime);
			
			sc1 = new Suggestion();
			sc1.content = "bgl1";
			sc1.position = new Position("gl-sp2", pos.beginTime, pos.endTime);
			s2.children.add(sc1);
			
			sc2 = new Suggestion();
			sc2.content = "bps1";
			sc2.position = new Position("ps-sp2", pos.beginTime, pos.endTime);
			//s2.children.add(sc2);
			
			ss.suggestions.add(s2);
			ss.suggestions.add(sc2);
			suggestionSets.add(ss);
			
			Suggestion s3 = new Suggestion();
			s3.content = "bb2";
			s3.position = new Position("mor-sp2", pos.beginTime, pos.endTime);
			
			sc1 = new Suggestion();
			sc1.content = "bgl2";
			sc1.position = new Position("gl-sp2", pos.beginTime, pos.endTime);
			s3.children.add(sc1);
			
			ss.suggestions.add(s3);
			
			//mediator.newAnnotations(suggestionSets);
			viewer.suggestionSetDelivered(new SuggestionSetEvent(viewer, suggestionSets));
		}

	}

}
