package mpi.eudico.client.annotator.interlinear.edit.event;

import java.util.EventObject;
import java.util.List;

import nl.mpi.lexan.annotyzers.helpers.SuggestionSet;

/**
 * An event object to transfer incoming suggestion sets to the user interface. 
 * 
 * @author Han Sloetjes
 */
public class SuggestionSetEvent extends EventObject {
	private List<SuggestionSet> suggestions;
	
	/**
	 * @param source
	 */
	public SuggestionSetEvent(Object source, List<SuggestionSet> suggestions) {
		super(source);
		
		this.suggestions = suggestions;
	}

	/**
	 * Returns the list containing the suggestion sets. 
	 * 
	 * @return the list of suggestion sets
	 */
	public List<SuggestionSet> getSuggestionSets() {
		return suggestions;
	}
}
